//+------------------------------------------------------------------+
//|                                                     Trailing.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters
extern int TrailingStop = 50;

void Trailing()
{
 for(int cnt=0;cnt<OrdersTotal();cnt++)
  if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
   {
    int orderType=OrderType();
    if(orderType<=OP_SELL && //      
       OrderSymbol()==Symbol()) // check for symbol
      {
       if(orderType==OP_BUY) //    
         {
          // check for trailing stop
          if(TrailingStop>0) 
           { 
            if(Bid-OrderOpenPrice()>Point*TrailingStop)
              {
               if(OrderStopLoss()<Bid-Point*TrailingStop)
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                  Print("Order BUY Tral modify ",Bid-Point*TrailingStop);
                  return(0);
                 }
              }
           } 
         }
        else //    
         {
          // check for trailing stop
          if(TrailingStop>0) 
           { 
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
              if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                Print("Order SELL Tral modify ",Ask+Point*TrailingStop);
                return(0);
               }
             }
           }
         }
      }
   }
 return(0);      
}

int init()
{
 OrderSend(Symbol(),OP_BUY,0.1,Ask,10,0,0,NULL,0);
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   Trailing();
 
   return(0);
  }
//+------------------------------------------------------------------+